#!/bin/bash
# ANR MEG PROJECT :http://mescal.imag.fr/membres/yves.denneulin/MEG/
# Denneulin, Barrios-Hernandez and Melo - LIG MESCAL LABORATORY @2009
# General Interface Script to Start the Work upon G5K for the SCT Users
# 

#Simple starter script for the use of oar and deployment of ambiance over G5K in Cluster 
#
#first  steep
JUST_A_SECOND=1
clear
echo " "
echo -n "***Welcome to SCT for Clusters Scheduling and Deployment Mode****"
echo " "
##########Function to work in interactive mode
interactivemode ()
{
clear
echo " "
echo -n "*** SIMPLE AND INTERACTIVE MODE ***"
echo " "
########## NODES QUANTITY
echo -n " "
echo -n "How many nodes do you need?: "
read NODES 
echo $NODES
while  [ -z "$NODES" ] ; 
	do
		echo "You need almost one node "
		echo -n "How many nodes do you need?: "
		read NODES
		echo $NODES
	done
########## Time To work
echo -n "How many time do you need?: (HH:MM:SS):  "
read TIME
if [ -z "$TIME" ]; then 
	echo -n "No Defined Time, Default time = 01:00:00" 
	TIME=1
elif [ "$TIME" = '0' ] ; then
	echo -n "Default time = 01:00:00" 
	TIME=1
else
	echo -n "Correct Time"
	echo $TIME
	read TIME
fi
####simple reservation with number of nodes in interactive mode
echo "OAR SUBMISSION PROCESS"
echo " "
oarsub -I -t deploy -l nodes=$NODES,walltime=$TIME
sleep $JUST_A_SECOND 
cat $OAR_NODEFILE > SCTMachines_$OAR_JOB_ID
#####Folder Creation to folder to backup work in the nodes
NOW=$(date +%Y-%m-%d\ %H:%M:%S)
mkdir SCTBackupSession_$OAR_JOB_ID
echo "Session $TODAY Job ID $OAR_JOB_ID "

echo -n \a "You are in Interactive Mode, You must Launch Manually the Script SCTClusterDeployment.sh "
echo " "
#exit
}
#######################################################################
######################################################################
### function to passive mode
passivemode ()
{
clear
echo " "
echo -n "*** PASSIVE MODE ***"
echo " "
########## NODES QUANTITY
echo -n " "
echo -n "How many nodes do you need?: "
read NODES 
echo $NODES
while  [ -z "$NODES" ] ; 
	do
		echo "You need almost one node "
		echo -n "How many nodes do you need?: "
		read NODES
		echo $NODES
	done
########## Actual Time
NOW=$(date +%Y-%m-%d\ %H:%M:%S)
echo "Actual Date and Time $NOW "
echo " "
########## Time To work
echo -n "How many time do you need?: (HH:MM:SS):  "
read TIME
if [ -z "$TIME" ]; then 
	echo -n "No Defined Time, Default time = 01:00:00" 
	TIME=1
elif [ "$TIME" = '0' ] ; then
	echo -n "Default time = 01:00:00" 
	TIME=1
else
	echo -n "Correct Time"
	echo $TIME
	read TIME
fi
############ Reservation date to start the work
echo -n " When you need start your work?:(HH:MM:SS):  "
read START_TIME
while [-z "$START_TIME" ] ;
	do 
	   	echo -n "You need to define a date and hour to start the SCT Work"
   		echo -n " When you need start your work?:(HH:MM:SS):  "
   		read START_TIME
		echo $START_TIME
	done
if [ "$START_TIME" < "$NOW" ] ; then
	echo -n "Incorrect Start Time."
	echo -n " When you need start your work?:(HH:MM:SS):  "
   	read START_TIME
	echo $START_TIME
else
	echo -n " Correct Date and Hour Selected"
	echo $START_TIME
	read $START_TIME
fi
##########
####simple reservation with number of nodes in Passive mode
echo "OAR SUBMISSION PROCESS"
echo " "
oarsub -r '$START_TIME' -l nodes=$NODES,walltime=$TIME ~/SCTSripts/SCTClusterDeployment.sh
sleep $JUST_A_SECOND
cat $OAR_NODEFILE > SCTMachines_$OAR_JOB_ID.$START_TIME
#####Folder Creation to folder to backup work in the nodes
mkdir SCTBackupSession_$OAR_JOB_ID.$START_TIME
echo "Session $TODAY Job ID $OAR_JOB_ID"
#
############ SCRIPT OF DEPLOYMENT IN PASSIVE MODE

#exit
}
#
#
#NOW TO CALL THE FUNCTIONS IN ACCORDANCE WITH THE SELECTION
echo -n "What mode you like to work? (Interactive=I, Passive=P): "
if [ "$MODE" = 'I' ]; then
	echo -n "Interactive Mode Selected"
        interactive
elif [ "$MODE" = 'P' ]
	echo -n " Passive Mode Selected "
	passivemode
else
	echo -n "Interactive mode by Default"
	interactive
fi
####
#exit
###
