#!/bin/bash
# ANR MEG PROJECT :http://mescal.imag.fr/membres/yves.denneulin/MEG/
# Denneulin, Barrios-Hernandez and Melo - LIG MESCAL LABORATORY @2009
# General Execution Script for SCT Plugin
# Using Taktuk (R) 
# The principle of this Script is to execute in all nodes the same 
#
# EXECUTION MODE TO CLUSTERS ------ SIMPLE USE ----
# Remember: the name of the file that it contains the name of the machines is SCTMachines
#
#
#
#
#Initialisation and distribution of the machines/nodes to calculate
JUST_TWO_SECONDS=2
echo ' '
echo "Execution Cluster Mode with Taktuk"
echo " "
echo " Interactive Mode "
echo " "
cat $OAR_NODEFILE > SCTMachines_$OAR_JOB_ID
#Take the reserverd nodes and the number of nodes reserved to distribute the codes in the node groups
#
#
#
# The first step of the compute is to send the codes Hcreat, Zantcreat, Zcreat, Zmemscreat and Ymodecreat
# The number of nodes are divided in 5 nodes set and the compute is sended for each group
# If the number of nodes is not multiple or 5, non problem, the mod operation allows to use a same quantity of nodes by compute
echo -n " Number of nodes: "
read $NODES
Groupes=$( echo "scale=0; $NODES/5.0" | bc) # Number of nodes by Group created
echo -n "There are $Groupes nodes by Group"
echo " "
G=$Groupes 
#First Selection to run Hcreat
echo "$G"
i=1
for m in `seq $i $G`; 
	do
#Now is necessary to create the taktuk command to execution
#		echo "running Code HCreat in $m"
		echo `head -$m  SCTMachines_$OAR_JOB_ID |tail -1` >> HCreatMachines
		taktuk -s -f HCreatMachines broadcast exec { bash }\; broadcast input file{ ./Hcreat }
		#taktuk -m $FIRSTMACHINE -f SCTMachines_$OAR_JOB_ID broadcast get { Screat.ctf } { /home/g5k/SCTBackupSession_$OAR_JOB_ID.$START_TIME/ }

	done
echo " "
echo " "
echo "***************************************"
#Second Selection to run Zantcreat
i=$(( $G + 1 ))
echo "$i"
G=$(( $G + $Groupes ))
echo "$G"
for m in `seq $i $G`; 
	do
#		echo "running Code Zantcreat in $m"
		echo `head -$m  SCTMachines_$OAR_JOB_ID |tail -1` >> ZantCreatMachines
		taktuk -s -f ZantCreatMachines broadcast exec{ bash }\; broadcast input file { ./Zantcreat }

 	done
echo "***************************************"
#Third Selection to run Zcreat
echo " "
echo " "
i=$(( $G + 1 ))
echo "$i"
G=$(( $G + $Groupes ))
echo "$G"
for m in `seq $i $G`; 
	do
#		echo "running Code Zcreat in $m"
		echo `head -$m  SCTMachines_$OAR_JOB_ID |tail -1` >> ZCreatMachines
		taktuk -s -f ZCreatMachines broadcast exec{ bash }\; broadcast input file { ./Zcreat }		
	done
echo "***************************************"
#Fourth selection to run YmodCreat
echo " "
echo " "
i=$(( $G + 1 ))
echo "$i"
G=$(( $G + $Groupes ))
echo "$G"
for m in `seq $i $G`; 
	do
#		echo "running Code YmodCreat in $m"
		echo `head -$m SCTMachines_$OAR_JOB_ID |tail -1` >> YmodcreatMachines
		taktuk -s -f YmodcreatMachines broadcast exec { bash }\; broadcast input file { ./YmodcreatMachines }
	done
echo "***************************************"
#Fifth selection to run Zmemcreat
echo " "
echo " "
i=$(( $G + 1 ))
echo "$i"
G=$(( $G + $Groupes ))
echo "$G"
for m in `seq $i $G`; 
	do
#		echo "running Code Zmemcreat in $m"
		echo `head -$m  SCTMachines_$OAR_JOB_ID |tail -1` >> ZmemcreatMachines
		taktuk -s -f ZmemcreatMachines broadcast exec { bash }\; broadcast input file { ./ZmemcreatMachines }
	done
echo "***************************************"
echo " "
echo " "
echo "***************************************"
echo "***************************************"
#
## The second step implies the execution of the codes HIvbacreat, HIvbalcreat and SCreat in all nodes not distributed 
taktuk -s -f SCTMachines_$OAR_JOB_ID broadcast exec  exec { bash }\; broadcast input file { ./HIvbacreat }
#
sleep $JUST_TWO_SECONDS
#
#This line is to recuperate the output files from all nodes... after the execution.
taktuk -m $FIRSTMACHINE -f SCTMachines_$OAR_JOB_ID broadcast get { HIvbacreat.ctf } { /home/g5k/SCTBackupSession_$OAR_JOB_ID.$START_TIME/ }

#
echo " "
echo "***************************************"
#
taktuk -s -f SCTMachines_$OAR_JOB_ID broadcast exec { bash }\; broadcast input file { ./HIvbalcreat }
#
sleep $JUST_TWO_SECONDS
#
taktuk -m $FIRSTMACHINE -f SCTMachines_$OAR_JOB_ID broadcast get { HIvbalcreat.ctf } { /home/g5k/SCTBackupSession_$OAR_JOB_ID.$START_TIME/ }
#

echo " "
echo "***************************************"
#
taktuk -s -f SCTMachines_$OAR_JOB_ID broadcast exec { bash }\; broadcast input file { ./Screat }
#
sleep $JUST_TWO_SECONDS
#
echo " "
echo "***************************************"
#
taktuk -m $FIRSTMACHINE -f SCTMachines_$OAR_JOB_ID broadcast get { Screat.ctf } { /home/g5k/SCTBackupSession_$OAR_JOB_ID.$START_TIME/ }
#
exit 
