#!/bin/bash
# ANR MEG PROJECT :http://mescal.imag.fr/membres/yves.denneulin/MEG/
# Denneulin, Barrios-Hernandez and Melo - LIG MESCAL LABORATORY @2009
# General Interface Script to Start the Work upon G5K for the SCT Users
# 

#Simple starter script for the use of oar and deployment of ambiance over G5K on Grid Environment
#
#first  steep
JUST_A_SECOND=1
clear
echo " "
echo -n "***Welcome to SCT Grid Scheduling and Deployment Mode****"
echo " "
##########Function to work in interactive mode
Gridinteractivemode ()
{
########## Time To work
echo -n "How many time do you need?: (HH:MM:SS):  "
read TIME
if [ -z "$TIME" ]; then 
	echo -n "No Defined Time, Default time = 01:00:00" 
	TIME=1
elif [ "$TIME" = '0' ] ; then
	echo -n "Default time = 01:00:00" 
	TIME=1
else
	echo -n "Correct Time"
	echo $TIME
	read TIME
fi
echo " "
########## NODES QUANTITY
echo -n " "
echo -n "How many nodes do you need by Cluster?: "
read NODES 
echo $NODES
while  [ -z "$NODES" ] ; 
	do
		echo "You need almost one node "
		echo -n "How many nodes do you need by Cluster?: "
		read NODES
		echo $NODES
	done
############ SELECTION OF CLUSTERS AND SITES ##################
echo -n "How many clusters do you need? (min 2, max 5): "
read CLUSTERS
echo $CLUSTERS
while  [ -z "$CLUSTERS" ] ; 
	do
		echo "You need almost two (2) Clusters "
		echo -n "How many clusters do you need?: "
		read CLUSTERS
		echo $CLUSTERS
	done

echo " "
############## FOR EACH SELECTION AUTOMATICALLY SENDS THE OARGRIDSUB TASKS #########################################
case $CLUSTERS in
	2)      echo -n "What Clusters are you need? (Please see the ListOfClusters file and write them separed by spaces)): "
		read CLUSTER_1 CLUSTER_2
		echo "$CLUSTER_1 and $CLUSTER_2 selected"
		oargridsub -v -w '$TIME' $CLUSTER_1:rdef="/nodes=$NODES",$CLUSTER_2:rdef="/$NODES":type="deploy"
		;;
	3) echo -n "What Clusters are you need? (Please see the ListOfClusters file and write them separed by spaces)): "
		read CLUSTER_1 CLUSTER_2 CLUSTER_3
		echo "$CLUSTER_1, $CLUSTER_2 and $CLUSTER_3"
		oargridsub -v -w '$TIME' $CLUSTER_1:rdef="/nodes=$NODES",$CLUSTER_2:rdef="/$NODES",$CLUSTER_3:rdef="/$NODES":type="deploy"
		;;
	4) echo -n "What Clusters are you need? (Please see the ListOfClusters file and write them separed by spaces): "
		read CLUSTER_1 CLUSTER_2 CLUSTER_3 CLUSTER_4
		echo "$CLUSTER_1, $CLUSTER_2, $CLUSTER_3 and $CLUSTER_4 selected"
		oargridsub -v -w '$TIME' $CLUSTER_1:rdef="/nodes=$NODES",$CLUSTER_2:rdef="/$NODES",$CLUSTER_3:rdef="/$NODES",$CLUSTER_4:rdef="/$NODES":type="deploy"
		;;
	5) echo -n "What Clusters are you need? (Please see the ListOfClusters file and write them separed by spaces): "
		read CLUSTER_1 CLUSTER_2 CLUSTER_3 CLUSTER_4 CLUSTER_5
		echo "$CLUSTER_1, $CLUSTER_2, $CLUSTER_3, $CLUSTER_4 and $CLUSTER_5 selected"
		oargridsub -v -w '$TIME' $CLUSTER_1:rdef="/nodes=$NODES",$CLUSTER_2:rdef="/$NODES",$CLUSTER_3:rdef="/$NODES",$CLUSTER_4:rdef="/$NODES",$CLUSTER_5:rdef="/$NODES":type="deploy"
		;;
esac
echo " Mode Interactive Availaible, please launch Grid deployment script manually" 
echo " "

########################################
sleep $JUST_A_SECOND 
echo -n "Type your number of Grid Job: "
read IdJob
oargridstat -w -l $IdJob > SCTMachinesGrid
#####Folder Creation to folder to backup work in the nodes
NOW=$(date +%Y-%m-%d\ %H:%M:%S)
mkdir SCTBackupSession_$IdJob
echo "Session $TODAY"
echo " "
echo -n \a "You are in Interactive Mode, You must Launch Manually the Script SCTGridDeployment.sh "
echo " "
#exit
}
#######################################################################
######################################################################
### function to passive mode
Gridpassivemode ()
{
clear
echo " "
echo -n "*** PASSIVE MODE ***"
echo " "
########## NODES QUANTITY
echo -n " "
echo -n "How many nodes do you need?: "
read NODES 
echo $NODES
while  [ -z "$NODES" ] ; 
	do
		echo "You need almost one node "
		echo -n "How many nodes do you need?: "
		read NODES
		echo $NODES
	done
########## Actual Time
NOW=$(date +%Y-%m-%d\ %H:%M:%S)
echo "Actual Date and Time $NOW "
echo " "
########## Time To work
echo -n "How many time do you need?: (HH:MM:SS):  "
read TIME
if [ -z "$TIME" ]; then 
	echo -n "No Defined Time, Default time = 01:00:00" 
	TIME=1
elif [ "$TIME" = '0' ] ; then
	echo -n "Default time = 01:00:00" 
	TIME=1
else	
	echo -n "Correct Time"
	echo $TIME
	read TIME
fi
############ Reservation date to start the work
echo -n " When you need start your work?:(HH:MM:SS):  "
read START_TIME
while [-z "$START_TIME" ] ;
	do 
	   	echo -n "You need to define a date and hour to start the SCT Work"
   		echo -n " When you need start your work?:(HH:MM:SS):  "
   		read START_TIME
		echo $START_TIME
	done
if [ "$START_TIME" < "$NOW" ] ; then
	echo -n "Incorrect Start Time."
	echo -n " When you need start your work?:(HH:MM:SS):  "
   	read START_TIME
	echo $START_TIME
else
	echo -n " Correct Date and Hour Selected"
	echo $START_TIME
	read $START_TIME
fi
##########
############ SELECTION OF CLUSTERS AND SITES ##################
echo -n "How many clusters do you need? (min 2, max 5): "
read CLUSTERS
echo $CLUSTERS
while  [ -z "$CLUSTERS" ] ; 
	do
		echo "You need almost two (2) Clusters "
		echo -n "How many clusters do you need?: "
		read CLUSTERS
		echo $CLUSTERS
	done

echo " "
############## FOR EACH SELECTION AUTOMATICALLY SENDS THE OARGRIDSUB TASKS #########################################
case $CLUSTERS in
	2)      echo -n "What Clusters are you need? (Please see the ListOfClusters file and write them separed by spaces)): "
		read CLUSTER_1 CLUSTER_2
		echo "$CLUSTER_1 and $CLUSTER_2 selected"
		oargridsub -v -s '$START_TIME' -w '$TIME' $CLUSTER_1:rdef="/nodes=$NODES",$CLUSTER_2:rdef="/nodes=NODES"
		;;
	3) echo -n "What Clusters are you need? (Please see the ListOfClusters file and write them separed by spaces)): "
		read CLUSTER_1 CLUSTER_2 CLUSTER_3
		echo "$CLUSTER_1, $CLUSTER_2 and $CLUSTER_3"
		oargridsub -v -s '$START_TIME' -w '$TIME' $CLUSTER_1:rdef="/nodes=$NODES",$CLUSTER_2:rdef="/nodes=NODES",$CLUSTER_3:rdef="/nodes=NODES"
		;;
	4) echo -n "What Clusters are you need? (Please see the ListOfClusters file and write them separed by spaces): "
		read CLUSTER_1 CLUSTER_2 CLUSTER_3 CLUSTER_4
		echo "$CLUSTER_1, $CLUSTER_2, $CLUSTER_3 and $CLUSTER_4 selected"
		oargridsub -v -s '$START_TIME' -w '$TIME' $CLUSTER_1:rdef="/nodes=$NODES",$CLUSTER_2:rdef="/nodes=NODES",$CLUSTER_3:rdef="/nodes=NODES",$CLUSTER_4:rdef="/nodes=NODES"
		;;
	5) echo -n "What Clusters are you need? (Please see the ListOfClusters file and write them separed by spaces): "
		read CLUSTER_1 CLUSTER_2 CLUSTER_3 CLUSTER_4 CLUSTER_5
		echo "$CLUSTER_1, $CLUSTER_2, $CLUSTER_3, $CLUSTER_4 and $CLUSTER_5 selected"
echo "$CLUSTER_1, $CLUSTER_2, $CLUSTER_3 and $CLUSTER_4 selected"
		oargridsub -v -s '$START_TIME' -w '$TIME' $CLUSTER_1:rdef="/nodes=$NODES",$CLUSTER_2:rdef="/nodes=NODES",$CLUSTER_3:rdef="/nodes=NODES",$CLUSTER_4:rdef="/nodes=NODES",$CLUSTER_5:rdef="/nodes=NODES"
			;;
esac
echo " Mode Passive Availaible" 
echo " "

############################################################
sleep $JUST_A_SECOND

#####Folder Creation to folder to backup work in the nodes
mkdir SCTBackupSession_$START_TIME
echo "Session $START_TIME"
#
############ SCRIPT OF DEPLOYMENT IN PASSIVE MODE

#exit
}
#
#
#NOW TO CALL THE FUNCTIONS IN ACCORDANCE WITH THE SELECTION
echo -n "What mode you like to work? (Interactive=I, Passive=P): "
if [ "$MODE" = 'I' ]; then
	echo -n "Interactive Mode Selected"
        Gridinteractive
elif [ "$MODE" = 'P' ]
	echo -n " Passive Mode Selected "
	passivemode
else
	echo -n "Interactive mode by Default"
	Gridinteractive
fi
####
#exit
###
